Index: /main/waeup.ikoba/trunk/docs/source/developerdocs/api/api_browser.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/api_browser.rst	(revision 12837)
+++ /main/waeup.ikoba/trunk/docs/source/developerdocs/api/api_browser.rst	(revision 12838)
@@ -18,10 +18,13 @@
    :maxdepth: 1
 
+   browser/api_async.rst
+   browser/api_breadcrumbs.rst
+   browser/api_captcha.rst
+   browser/api_exceptions.rst
+   browser/api_fileviewlets.rst
    browser/api_interfaces.rst
+   browser/api_layout.rst
    browser/api_pages.rst
+   browser/api_pdf.rst
+   browser/api_reports.rst
    browser/api_viewlets.rst
-   browser/api_layout.rst
-   browser/api_breadcrumbs.rst
-   browser/api_theming.rst
-   browser/api_resources.rst
-   browser/api_exceptions.rst
Index: /main/waeup.ikoba/trunk/docs/source/developerdocs/api/api_widgets.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/api_widgets.rst	(revision 12837)
+++ /main/waeup.ikoba/trunk/docs/source/developerdocs/api/api_widgets.rst	(revision 12838)
@@ -20,4 +20,3 @@
    widgets/api_datewidget
    widgets/api_phonewidget
-   widgets/api_restwidget
    widgets/api_objectwidget
Index: /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_async.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_async.rst	(revision 12838)
+++ /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_async.rst	(revision 12838)
@@ -0,0 +1,7 @@
+`browser.async` - Browser Job Components
+****************************************
+
+.. automodule:: waeup.ikoba.browser.async
+   :members:
+   :undoc-members:
+
Index: /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_breadcrumbs.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_breadcrumbs.rst	(revision 12837)
+++ /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_breadcrumbs.rst	(revision 12838)
@@ -1,4 +1,4 @@
-`browser.breadcrumbs` - Browser Breadcrumbs
-*******************************************
+`browser.breadcrumbs` - Breadcrumbs
+***********************************
 
 .. automodule:: waeup.ikoba.browser.breadcrumbs
Index: /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_captcha.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_captcha.rst	(revision 12838)
+++ /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_captcha.rst	(revision 12838)
@@ -0,0 +1,6 @@
+`browser.captcha` - Captcha Components
+**************************************
+
+.. automodule:: waeup.ikoba.browser.captcha
+   :members:
+   :undoc-members:
Index: /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_fileviewlets.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_fileviewlets.rst	(revision 12838)
+++ /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_fileviewlets.rst	(revision 12838)
@@ -0,0 +1,6 @@
+`browser.fileviewlets` - File Viewlets
+**************************************
+
+.. automodule:: waeup.ikoba.browser.fileviewlets
+   :members:
+   :undoc-members:
Index: /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_interfaces.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_interfaces.rst	(revision 12837)
+++ /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_interfaces.rst	(revision 12838)
@@ -5,14 +5,2 @@
    :members:
    :undoc-members:
-
-   .. autointerface:: IBreadcrumb
-      :members:
-
-   .. autointerface:: IBreadcrumbIgnorable
-      :members:
-
-   .. autointerface:: IBreadcrumbContainer
-      :members:
-
-   .. autointerface:: ITheme
-      :members:
Index: /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_layout.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_layout.rst	(revision 12837)
+++ /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_layout.rst	(revision 12838)
@@ -1,4 +1,4 @@
-`browser.layout` - Browser Layout
-*********************************
+`browser.layout` - Layout
+*************************
 
 .. automodule:: waeup.ikoba.browser.layout
Index: /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_pages.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_pages.rst	(revision 12837)
+++ /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_pages.rst	(revision 12838)
@@ -1,4 +1,4 @@
-`browser.pages` - Browser Pages (Views)
-***************************************
+`browser.pages` - Pages (Views)
+*******************************
 
 .. automodule:: waeup.ikoba.browser.pages
Index: /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_pdf.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_pdf.rst	(revision 12838)
+++ /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_pdf.rst	(revision 12838)
@@ -0,0 +1,6 @@
+`browser.pdf` - PDF Views
+*************************
+
+.. automodule:: waeup.ikoba.browser.pdf
+   :members:
+   :undoc-members:
Index: /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_reports.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_reports.rst	(revision 12838)
+++ /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_reports.rst	(revision 12838)
@@ -0,0 +1,6 @@
+`browser.reports` - Reports Components
+**************************************
+
+.. automodule:: waeup.ikoba.browser.reports
+   :members:
+   :undoc-members:
Index: in/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_resources.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_resources.rst	(revision 12837)
+++ 	(revision )
@@ -1,7 +1,0 @@
-`browser.resources` - Browser Resources
-***************************************
-
-.. automodule:: waeup.ikoba.browser.resources
-   :members:
-   :undoc-members:
-
Index: in/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_theming.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_theming.rst	(revision 12837)
+++ 	(revision )
@@ -1,7 +1,0 @@
-`browser.theming` - Browser Theming
-***********************************
-
-.. automodule:: waeup.ikoba.browser.theming
-   :members:
-   :undoc-members:
-
Index: /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_viewlets.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_viewlets.rst	(revision 12837)
+++ /main/waeup.ikoba/trunk/docs/source/developerdocs/api/browser/api_viewlets.rst	(revision 12838)
@@ -1,12 +1,6 @@
-`browser.viewlets` - Browser Viewlets
-*************************************
+`browser.viewlets` - Viewlets
+*****************************
 
-Probably due to a bug in Sphinx autodoc couldn't import/find some classes and
-reported error: "grokcore, please check your spelling and sys.path".
-Thus, automodule has been temporarily disabled.
-
-..
-  .. automodule:: waeup.ikoba.browser.viewlets
-     :members:
-     :undoc-members:
-
+.. automodule:: waeup.ikoba.browser.viewlets
+   :members:
+   :undoc-members:
Index: /main/waeup.ikoba/trunk/docs/source/developerdocs/api/index.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/index.rst	(revision 12837)
+++ /main/waeup.ikoba/trunk/docs/source/developerdocs/api/index.rst	(revision 12838)
@@ -23,4 +23,5 @@
    api_datacenter
    api_documents
+   api_image
    api_imagestorage
    api_interfaces
@@ -38,5 +39,4 @@
    api_sourcefactory
    api_startup
-   api_company
    api_userscontainer
    api_utils
Index: /main/waeup.ikoba/trunk/docs/source/developerdocs/api/payments/api_currencies.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/payments/api_currencies.rst	(revision 12838)
+++ /main/waeup.ikoba/trunk/docs/source/developerdocs/api/payments/api_currencies.rst	(revision 12838)
@@ -0,0 +1,6 @@
+`payments.currencies` - Currencies
+**********************************
+
+.. automodule:: waeup.ikoba.payments.currencies
+   :members:
+   :undoc-members:
Index: in/waeup.ikoba/trunk/docs/source/developerdocs/api/widgets/api_restwidget.rst
===================================================================
--- /main/waeup.ikoba/trunk/docs/source/developerdocs/api/widgets/api_restwidget.rst	(revision 12837)
+++ 	(revision )
@@ -1,6 +1,0 @@
-`widgets.restwidget` - ReST Widget
-**********************************
-
-.. automodule:: waeup.ikoba.widgets.restwidget
-   :members:
-   :undoc-members:
Index: /main/waeup.ikoba/trunk/src/waeup/ikoba/permissions.py
===================================================================
--- /main/waeup.ikoba/trunk/src/waeup/ikoba/permissions.py	(revision 12837)
+++ /main/waeup.ikoba/trunk/src/waeup/ikoba/permissions.py	(revision 12838)
@@ -28,7 +28,4 @@
     etc., that should be usable/readable by everyone.
 
-    We need this to be able to tune default permissions more
-    restrictive and open up some dedicated objects like the front
-    page.
     """
     grok.name('waeup.Public')
@@ -36,4 +33,5 @@
 class Anonymous(grok.Permission):
     """Only-anonymous-can-do-this-permission.
+
     """
     grok.name('waeup.Anonymous')