Index: /main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_browser.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_browser.py	(revision 12840)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/browser/tests/test_browser.py	(revision 12841)
@@ -383,44 +383,4 @@
         return
 
-class SupplementaryBrowserTests(UniversitySetup):
-    # These are additional tests to browser.txt
-
-    def test_set_former_course(self):
-        # A certificate course will be automatically removed when the
-        # former_course attribute of the corresponding course is set.
-        self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
-        self.assertTrue('COURSE1_100' in self.app[
-            'faculties']['fac1']['dep1'].certificates['CERT1'])
-        self.browser.open(
-            'http://localhost/app/faculties/fac1/dep1/courses/COURSE1/manage')
-        self.browser.getControl(name="form.former_course").value = ['selected']
-        self.browser.getControl("Save").click()
-        self.assertFalse('COURSE1_100' in self.app[
-            'faculties']['fac1']['dep1'].certificates['CERT1'])
-        return
-
-    def test_remove_course(self):
-        # We add a second certificate course which refers
-        # to the same course but at a different level.
-        self.app['faculties']['fac1']['dep1'].certificates[
-            'CERT1'].addCertCourse(
-            self.course, level=210)
-        # Both certificate courses will be automatically removed when
-        # the corresponding course is removed.
-        self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
-        self.assertTrue('COURSE1_100' in self.app[
-            'faculties']['fac1']['dep1'].certificates['CERT1'])
-        self.assertTrue('COURSE1_210' in self.app[
-            'faculties']['fac1']['dep1'].certificates['CERT1'])
-        self.browser.open('http://localhost/app/faculties/fac1/dep1/manage')
-        ctrl = self.browser.getControl(name='val_id')
-        ctrl.getControl(value='COURSE1').selected = True
-        self.browser.getControl("Remove selected", index=0).click()
-        self.assertFalse('COURSE1_100' in self.app[
-            'faculties']['fac1']['dep1'].certificates['CERT1'])
-        self.assertFalse('COURSE1_210' in self.app[
-            'faculties']['fac1']['dep1'].certificates['CERT1'])
-        return
-
     def test_user_data_import_permission(self):
         upload_path = 'http://localhost/app/datacenter/upload'
@@ -445,2 +405,42 @@
         self.assertTrue('User Processor' in self.browser.contents)
         return
+
+class SupplementaryBrowserTests(UniversitySetup):
+    # These are additional tests to browser.txt
+
+    def test_set_former_course(self):
+        # A certificate course will be automatically removed when the
+        # former_course attribute of the corresponding course is set.
+        self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
+        self.assertTrue('COURSE1_100' in self.app[
+            'faculties']['fac1']['dep1'].certificates['CERT1'])
+        self.browser.open(
+            'http://localhost/app/faculties/fac1/dep1/courses/COURSE1/manage')
+        self.browser.getControl(name="form.former_course").value = ['selected']
+        self.browser.getControl("Save").click()
+        self.assertFalse('COURSE1_100' in self.app[
+            'faculties']['fac1']['dep1'].certificates['CERT1'])
+        return
+
+    def test_remove_course(self):
+        # We add a second certificate course which refers
+        # to the same course but at a different level.
+        self.app['faculties']['fac1']['dep1'].certificates[
+            'CERT1'].addCertCourse(
+            self.course, level=210)
+        # Both certificate courses will be automatically removed when
+        # the corresponding course is removed.
+        self.browser.addHeader('Authorization', 'Basic mgr:mgrpw')
+        self.assertTrue('COURSE1_100' in self.app[
+            'faculties']['fac1']['dep1'].certificates['CERT1'])
+        self.assertTrue('COURSE1_210' in self.app[
+            'faculties']['fac1']['dep1'].certificates['CERT1'])
+        self.browser.open('http://localhost/app/faculties/fac1/dep1/manage')
+        ctrl = self.browser.getControl(name='val_id')
+        ctrl.getControl(value='COURSE1').selected = True
+        self.browser.getControl("Remove selected", index=0).click()
+        self.assertFalse('COURSE1_100' in self.app[
+            'faculties']['fac1']['dep1'].certificates['CERT1'])
+        self.assertFalse('COURSE1_210' in self.app[
+            'faculties']['fac1']['dep1'].certificates['CERT1'])
+        return